#ifndef PICODEC_H
#define PICODEC_H

#include "piprocess.h"

class PICodec: private PIProcess
{
public:
	PICodec(): PIProcess() {setGrabOutput(true); tf = PIFile::openTemporary(PIFile::New | PIFile::Read | PIFile::Write); tf.open();}
	PICodec(const PIString & from, const PIString & to): PIProcess() {setCodings(from, to); tf = PIFile::openTemporary(PIFile::New | PIFile::Read | PIFile::Write);}
	~PICodec() {tf.remove();}
	
	void setFromCoding(const PIString & from) {c_from = from;}
	void setToCoding(const PIString & to) {c_to = to;}
	void setCodings(const PIString & from, const PIString & to) {c_from = from; c_to = to;}
	
	PIStringList availableCodecs();
	PIString encode(PIString & str) {return PIString(exec_iconv(c_from, c_to, str.toByteArray()));}
	PIString encode(const PIByteArray & str) {return PIString(exec_iconv(c_from, c_to, str));}
	PIString decode(PIString & str) {return PIString(exec_iconv(c_to, c_from, str.toByteArray()));}
	PIString decode(const PIByteArray & str) {return PIString(exec_iconv(c_to, c_from, str));}
	
private:
	PIByteArray exec_iconv(const PIString & from, const PIString & to, const PIByteArray & str);
	
	PIString c_from, c_to;
	PIFile tf;
	
};

#endif // PICODEC_H
